"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.oneOrMore = oneOrMore;
exports.optional = optional;
exports.zeroOrMore = zeroOrMore;
var _encoder = require("../encoder/encoder");
var _elements = require("../utils/elements");
function zeroOrMore(sequence) {
  return {
    type: 'zeroOrMore',
    children: (0, _elements.ensureArray)(sequence),
    encode: encodeZeroOrMore
  };
}
function oneOrMore(sequence) {
  return {
    type: 'oneOrMore',
    children: (0, _elements.ensureArray)(sequence),
    encode: encodeOneOrMore
  };
}
function optional(sequence) {
  return {
    type: 'optional',
    children: (0, _elements.ensureArray)(sequence),
    encode: encodeOptional
  };
}
function encodeZeroOrMore() {
  return {
    precedence: 'sequence',
    pattern: `${(0, _encoder.encodeAtom)(this.children).pattern}*`
  };
}
function encodeOneOrMore() {
  return {
    precedence: 'sequence',
    pattern: `${(0, _encoder.encodeAtom)(this.children).pattern}+`
  };
}
function encodeOptional() {
  return {
    precedence: 'sequence',
    pattern: `${(0, _encoder.encodeAtom)(this.children).pattern}?`
  };
}
//# sourceMappingURL=quantifiers.js.map