"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.repeat = repeat;
var _encoder = require("../encoder/encoder");
var _elements = require("../utils/elements");
function repeat(sequence, count) {
  const children = (0, _elements.ensureArray)(sequence);
  if (children.length === 0) {
    throw new Error('`repeat` should receive at least one element');
  }
  return {
    type: 'repeat',
    children,
    count: count,
    encode: encodeRepeat
  };
}
function encodeRepeat() {
  var _this$count;
  const atomicNodes = (0, _encoder.encodeAtom)(this.children);
  if (typeof this.count === 'number') {
    return {
      precedence: 'sequence',
      pattern: `${atomicNodes.pattern}{${this.count}}`
    };
  }
  return {
    precedence: 'sequence',
    pattern: `${atomicNodes.pattern}{${this.count.min},${((_this$count = this.count) === null || _this$count === void 0 ? void 0 : _this$count.max) ?? ''}}`
  };
}
//# sourceMappingURL=repeat.js.map