import { encodeAtom } from '../encoder/encoder';
import { ensureArray } from '../utils/elements';
export function zeroOrMore(sequence) {
  return {
    type: 'zeroOrMore',
    children: ensureArray(sequence),
    encode: encodeZeroOrMore
  };
}
export function oneOrMore(sequence) {
  return {
    type: 'oneOrMore',
    children: ensureArray(sequence),
    encode: encodeOneOrMore
  };
}
export function optional(sequence) {
  return {
    type: 'optional',
    children: ensureArray(sequence),
    encode: encodeOptional
  };
}
function encodeZeroOrMore() {
  return {
    precedence: 'sequence',
    pattern: `${encodeAtom(this.children).pattern}*`
  };
}
function encodeOneOrMore() {
  return {
    precedence: 'sequence',
    pattern: `${encodeAtom(this.children).pattern}+`
  };
}
function encodeOptional() {
  return {
    precedence: 'sequence',
    pattern: `${encodeAtom(this.children).pattern}?`
  };
}
//# sourceMappingURL=quantifiers.js.map