import { encodeAtom } from '../encoder/encoder';
import { ensureArray } from '../utils/elements';
export function repeat(sequence, count) {
  const children = ensureArray(sequence);
  if (children.length === 0) {
    throw new Error('`repeat` should receive at least one element');
  }
  return {
    type: 'repeat',
    children,
    count: count,
    encode: encodeRepeat
  };
}
function encodeRepeat() {
  var _this$count;
  const atomicNodes = encodeAtom(this.children);
  if (typeof this.count === 'number') {
    return {
      precedence: 'sequence',
      pattern: `${atomicNodes.pattern}{${this.count}}`
    };
  }
  return {
    precedence: 'sequence',
    pattern: `${atomicNodes.pattern}{${this.count.min},${((_this$count = this.count) === null || _this$count === void 0 ? void 0 : _this$count.max) ?? ''}}`
  };
}
//# sourceMappingURL=repeat.js.map